<?php
defined('_JEXEC') or die('Restricted access.');

require_once(JPATH_ADMINISTRATOR.'/components/com_zoo/config.php');


class SefExt_com_zoo extends SefExt {

   function createCategoryPathway($categories, $category_id, &$categoryPathway) {
        $res = false;
        foreach ($categories as $category) {
            if ($category->id == $category_id) { // find OK :)
                $categoryPathway[] = $category;
                $res = true;
                break;
            }
            if (count($category->getChildren()) ) { // have childrens
                $categoryPathway[] = $category;
                $res = $this->createCategoryPathway($category->getChildren(), $category_id, $categoryPathway);
                if ($res) {
                    break;
                }
            }

        }
        if (!$res) {
            array_pop($categoryPathway);
        }
        return $res;
    }   
    
    function getCategoriesTree($app_id, $category_id) {
        
        $application = YTable::getInstance('application')->get($app_id);
        $categories = $application->getCategoryTree();

        $category_pathway = array();
        $this->createCategoryPathway($categories[0]->getChildren(), $category_id, $category_pathway);
        
        return $category_pathway;
    }
        
    function create(&$uri) {
        $title = array();

        // get query parameters
        $query = $uri->getQuery(true);
        //extract($query);
        $Itemid = isset($query['Itemid']) ? $query['Itemid'] : '';
        
        // if task is empty get task from view parameter
        $task = !empty($query['task']) ? $query['task'] : (isset($query['view']) ? $query['view'] : null);
        
        $controller = isset($query['controller']) ? $query['controller'] : null;
        
        $dosef = true;
        // ignore ajax requests
        if (in_array($task, array('remove', 'callelement', 'element')) || in_array($controller, array('comment'))) {
            $dosef = false;
        }
        
        $menu_params = JSite::getMenu()->getParams($Itemid);
        
        $query['app_id']      = isset($query['app_id'])      ? $query['app_id']      : $menu_params->get('application', 0); 
        $query['category_id'] = isset($query['category_id']) ? $query['category_id'] : $menu_params->get('category', 0); 
        $query['item_id']     = isset($query['item_id'])     ? $query['item_id']     : $menu_params->get('item_id', 0); 
        
        if ($query['category_id'] != 0) {
            $primaryCategory = YTable::getInstance('category')->get($query['category_id']);
            if ($query['app_id'] == 0) {
                $query['app_id'] = $primaryCategory->application_id;
            }
            $category_pathway = $this->getCategoriesTree($query['app_id'], $query['category_id']);
            foreach ($category_pathway as $category) {
                if ($category->id != $query['category_id']) { 
                    $title[] = $category->alias;
                }
            }
        }
        
        switch ($task) {
            case 'alphaindex':
                $title[] = $task;
//              $title[] = ApplicationHelper::translateIDToAlias((int) $query['app_id']);
                $title[] = $query['alpha_char'];
                break;
        
            case 'feed':
            case 'category':
                if (isset($primaryCategory->id)) {
                    $title[] = $primaryCategory->alias;
                    $uri->setVar('category_id', $primaryCategory->id);
                    $uri->setVar('task', 'category');
                    $uri->setVar('view', 'category');
                }
                if (isset($query['date'])) {
                    $dates = explode('-', $query['date']);
                    $title = array_merge($title, $dates);                   
                }
                if ($task == 'feed') {
                    $title[] = $task .'-'. $query['type'];
                }
                break;
        
            case 'frontpage':
                $title[] = ApplicationHelper::translateIDToAlias($query['app_id']);
                break;
        
            case 'item':
                $item = YTable::getInstance('item')->get($query['item_id']);
                $category = $item->getPrimaryCategory();
                $uri->setVar('category_id', 0);
                if (isset($category->id)) {
                    $title[] = $category->alias;
                    $uri->setVar('category_id', $category->id);
                }
                $uri->setVar('task', 'item');
                $uri->setVar('view', 'item');
                $uri->setVar('item_id', $query['item_id']);             
                $title[] = ItemHelper::translateIDToAlias((int) $query['item_id']);
                break;
        
            case 'submission':
                // retrieve item id from menu item
                if (!isset($query['submission_id'])) {
                    $query['submission_id'] = $menu_params->get('submission');
                    $query['type_id'] = $menu_params->get('type');
                    $query['item_id'] = $menu_params->get('item_id');
                    $query['submission_hash'] = '';
                }
                if ($query['layout'] == 'submission') {
                    $title[] = $task;
                    $title[] = $query['layout'];
                    $title[] = SubmissionHelper::translateIDToAlias((int) $query['submission_id']);
                    $title[] = $query['type_id'];
                    $title[] = $query['submission_hash'];
                    $title[] = ItemHelper::translateIDToAlias((int) @$query['item_id']);
        
                } else if ($query['layout'] == 'mysubmissions') {
                    $title[] = $task;
                    $title[] = $query['layout'];
                    $title[] = SubmissionHelper::translateIDToAlias((int) $query['submission_id']);
                }
                break;
        
            case 'tag':
                $title[] = 'tags';
                $title[] = $query['tag'];               
                
                break;
        
            default:
        }

        //pagination
        if (isset($query['page']) && $task != 'feed') {
            $title[] = $query['page'];
        }       
        
        $uri->setVar('app_id', $query['app_id']);
        
        
        $newUri = $uri;
        $lang = JFactory::getLanguage();
        if (count($title) > 0 && $dosef) {
            $ignoreVars = array();
            if (isset($limit))      $ignoreVars['limit']      = isset($query['limit']) ? $query['limit'] : '';
            if (isset($limitstart)) $ignoreVars['limitstart'] = isset($query['limitstart']) ? $query['limitstart'] : '';
            
            $newUri = JoomSEF::_sefGetLocation($uri, $title, null, null, null, @$lang, null, $ignoreVars);
        }
        
        return $newUri;
    }
    
}