<?php
/**
* @version 1.3.0
* @package RSform!Pro 1.3.0
* @copyright (C) 2007-2010 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * RSForm! Pro system plugin
 */
class plgSystemRSFPMappings extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatibility we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemRSFPMappings( &$subject, $config )
	{
		parent::__construct( $subject, $config );
	}
	
	function canRun()
	{
		if (class_exists('RSFormProHelper')) return true;
		
		$helper = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsform'.DS.'helpers'.DS.'rsform.php';
		if (file_exists($helper))
		{
			require_once($helper);
			RSFormProHelper::readConfig();
			return true;
		}
		
		return false;
	}
	
	/*
		Event Triggered Functions
	*/
	function rsfp_bk_onSwitchTasks()
	{
		if (!$this->canRun()) return;
		
		$plugin_task = JRequest::getVar('plugin_task');
		switch($plugin_task)
		{
			case 'mappings.getColumns':
				$this->mappingsGetColumns();
				exit();
			break;
			
			case 'mappings.saveMapping':
				$this->mappingsSaveMapping();
				exit();
			break;
			
			case 'mappings.deleteMapping':
				$this->mappingsDeleteMapping();
				exit();
			break;
			
			default:
			break;
		}
	}
	
	function rsfp_bk_onAfterShowFormEditTabs()
	{
		if (!$this->canRun()) return;
		
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpmappings' );
		
		jimport('joomla.html.pane');
		$tabs =& JPane::getInstance('Tabs', array(), true);
		
		$formId = JRequest::getInt('formId');
		
		echo $tabs->startPanel(JText::_('RSFP_MAPPINGS_LABEL'), 'form-mappings');
			$this->mappingsScreen($formId);
		echo $tabs->endPanel();
	}
	
	function rsfp_f_onAfterStoreSubmissions($args)
	{
		$db = JFactory::getDBO();
		
		$columns = array();
		$components = array();
		
		// If there are mappings, map the selected components to the selected tables
		$db->setQuery("SELECT * FROM `#__rsform_mappings` m LEFT JOIN `#__rsform_components` c ON m.ComponentId = c.ComponentId WHERE c.FormId = ".(int) $args['formId']." AND c.Published = 1");
		$results = $db->loadObjectList();
		foreach ($results as $result)
		{
			$columns[$result->MappingTable][$result->MappingId] = $db->getEscaped($result->MappingColumn);
			$components[$result->MappingTable][$result->MappingId] = $db->getEscaped($this->getSubmissionValue($args['SubmissionId'], $result->ComponentId));
		}
		
		if (!empty($columns))
			foreach ($columns as $table => $rows)
			{
				$db->setQuery("INSERT INTO `".$table."` (`".implode("`,`", $rows)."`) VALUES ('".implode("','", $components[$table])."')");
				$db->query();
			}
	}
	
	/*
		Task Functions
	*/
	function mappingsGetColumns()
	{
		echo $this->drawColumnsSelect(JRequest::getVar('tableName', ''));
	}
	
	function mappingsSaveMapping()
	{
		$db = JFactory::getDBO();
		
		$formId = JRequest::getInt('FormId');
		$componentId = JRequest::getInt('ComponentId');
		$table = JRequest::getVar('MappingTable');
		$column = JRequest::getVar('MappingColumn');
		
		$db->setQuery("SELECT MappingId FROM #__rsform_mappings WHERE ComponentId='".$componentId."' AND MappingTable='".$db->getEscaped($table)."' AND MappingColumn='".$db->getEscaped($column)."'");
		if ($db->loadResult())
		{
			echo 1;
			return;
		}
		
		$db->setQuery("INSERT INTO #__rsform_mappings SET ComponentId='".$componentId."', MappingTable='".$db->getEscaped($table)."', MappingColumn='".$column."'");
		$db->query();
		
		echo $this->drawMappingsTable($formId);
	}
	
	function mappingsDeleteMapping()
	{
		$db = JFactory::getDBO();
		
		$formId = JRequest::getInt('FormId');
		$id = JRequest::getInt('MappingId');
		
		$db->setQuery("DELETE FROM #__rsform_mappings WHERE MappingId='".$id."'");
		$db->query();
		
		echo $this->drawMappingsTable($formId);
	}
	
	/*
		Additional Functions
	*/
	function mappingsScreen($formId)
	{
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpmappings' );
		
	    ?>
	    <table cellpadding="4" cellspacing="0" border="0" class="adminform">
	    <tr>
	          <th colspan="2"><?php echo JText::_('RSFP_MAPPINGS_LABEL'); ?>
	          	<a href="http://www.rsjoomla.com/rsform-pro-mapping-plugin.html" target="_blank"><?php echo JHTML::image('administrator/components/com_rsform/assets/images/icons/info.png', JText::_('RSFP_MAPPINGS_LABEL')); ?></a>
	          </th>
	      </tr>
	      <tr>
	          <td valign="top" align="left" width="100%">
	              <table>
	                  <tr>
	                    <td width="1%" valign="top">
						<?php echo JText::_('RSFP_MAPPINGS_COMPONENT_NAME');?>
						<div id="rsform_html_unmapped_select">
							<?php echo $this->drawUnmappedSelect($formId); ?>
						</div><br />
						<?php echo JText::_('RSFP_MAPPINGS_TABLE_TO_MAP');?>
						<div id="rsform_html_mapping_table">
							<?php echo $this->drawTablesSelect(); ?>
						</div><br />
						<?php echo JText::_('RSFP_MAPPINGS_COLUMN_TABLE_TO_MAP');?>
						<div id="rsform_html_mapping_column">
							<?php echo $this->drawColumnsSelect(); ?>
						</div><br />
						
						<input type="button" value="Add mapping" onclick="saveMapping(<?php echo $formId; ?>)">
						</td>
						<td valign="top">
						<div id="rsform_html_mappings_table"><?php echo $this->drawMappingsTable($formId); ?></div>
						</td>
					 </tr>
					</table>
				</td>
			</tr>
			<tr>
				<td colspan="2"><?php echo JText::_('RSFP_MAPPINGS_DESC');?></td>
			</tr>
		</table>
	    <?php
	}

	function drawUnmappedSelect($formId)
	{
		$db = JFactory::getDBO();
		$db->setQuery("SELECT p.PropertyValue AS `text`, c.ComponentId AS `value` FROM #__rsform_components c LEFT JOIN #__rsform_properties p ON (c.ComponentId=p.ComponentId AND p.PropertyName='NAME') WHERE c.FormId='".(int) $formId."' ORDER BY c.Order");
		$components = $db->loadObjectList();
		
		$return = JHTML::_('select.genericlist', $components, 'rsform_mapping_component', null, 'value', 'text', null, 'rsform_mapping_component');
		return $return;
	}
	
	
	function drawTablesSelect()
	{
		$tables = $this->getTables();
		$options = array();
		foreach ($tables as $table)
			$options[] = JHTML::_('select.option', $table, $table);
		
		$return = JHTML::_('select.genericlist', $options, 'rsform_mapping_table', 'onchange="updateColumns()"', 'value', 'text', null, 'rsform_mapping_table');
		return $return;
	}
	
	function drawColumnsSelect($tableName='')
	{
		if (!empty($tableName))
			$columns = $this->getColumns($tableName);
		else
		{
			$tables = $this->getTables();
			$columns = $this->getColumns($tables[0]);
		}
		
		$options = array();
		foreach ($columns as $column)
			$options[] = JHTML::_('select.option', $column, $column);
		
		$return = JHTML::_('select.genericlist', $options, 'rsform_mapping_column', null, 'value', 'text', null, 'rsform_mapping_column');
		return $return;
	}
	
	function getTables()
	{
		$db = JFactory::getDBO();
		$db->setQuery("SHOW TABLES");
		
		$tables = array();
		$rows = $db->loadRowList();
		foreach ($rows as $row)
			$tables[] = $row[0];
		
		return $tables;
	}
	
	function getColumns($tableName)
	{		
		$db = JFactory::getDBO();
		$db->setQuery("SHOW COLUMNS FROM `".$db->getEscaped($tableName)."`");
		
		$columns = array();
		$rows = $db->loadRowList();
		foreach ($rows as $row)
			$columns[] = $row[0];
			
		return $columns;
	}
	
	function drawMappingsTable($formId)
	{
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpmappings' );
		
		$db = JFactory::getDBO();
		$db->setQuery("SELECT m.* FROM #__rsform_mappings m LEFT JOIN #__rsform_components c ON (m.ComponentId = c.ComponentId) WHERE c.FormId='".(int) $formId."' ORDER BY m.MappingTable, m.MappingColumn");
		$results = $db->loadObjectList();
		
		$return = '<table border="0" class="adminlist">
			<thead>
			<tr>
				<th>Component</th>
				<th>Map to</th>
				<th width="1%">Action</th>
			</tr>
			</thead>
			';
		
		$all_data = RSFormProHelper::getComponentProperties($results);
		$k = 0;
		foreach ($results as $result)
		{
			$data = $all_data[$result->ComponentId];
			
			$return .= '<tr class="row'.$k.'">';
			$return .= '<td>'.$data['NAME'].'</td>';
			$return .= '<td>'.$result->MappingTable.'.'.$result->MappingColumn.'</td>';
			$return .= '<td><a href="javascript: void(0);" onclick="if (confirm(\''.JText::_('VALIDDELETEITEMS', true).'\')) deleteMapping('.$result->MappingId.','.$formId.')">'.JText::_('DELETE').'</a></td>';
			$return .= '</tr>';
			
			$k=1-$k;
		}
		
		$return .= '</table>';		
		return $return;
	}
	
	function getSubmissionValue($SubmissionId, $componentId)
	{
		$data = RSFormProHelper::getComponentProperties($componentId);
		
		$db = JFactory::getDBO();
		$db->setQuery("SELECT `FieldValue` FROM #__rsform_submission_values WHERE FieldName = '".$db->getEscaped($data['NAME'])."' AND SubmissionId = '".(int) $SubmissionId."'");
		return $db->loadResult();
	}
}