<?php

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class JBlankHelper {

    function getPathTemplate() {
        $document   = & JFactory::getDocument();
        return JURI::root().'templates/'.$document->template;
    }
    
    function includeIEHacks() {
        $document   = & JFactory::getDocument();        
        $cssFiles = JFolder::files(JPATH_THEMES.DS.$document->template.DS.'css');
        $conditions = array('lt', 'lte', 'gt', 'gte');
        $path = JBlankHelper::getPathTemplate();
        foreach ($cssFiles as $cssFile) {
            $version = $condition = $not = '';
            $cssFile = JFile::stripExt($cssFile);
            if (strpos($cssFile, 'msie') !== false) {
                $cssInfo = explode('-', $cssFile);
                foreach($conditions as $cond) { if (in_array($cond, $cssInfo)) { $condition = $cond.' '; break; } }
                foreach($cssInfo as $info) { if ($info > 5) { $version = $info; break; } }
                $cssPath = JPATH_THEMES.DS.$document->template.DS.'css'.DS.$cssFile.'.css';
                if(JFile::exists($cssPath) && filesize($cssPath) > 10) {
                    $document->addCustomTag('<!--[if '.$condition.'IE '.$version.']><link href="'.$path.'/css/'.$cssFile.'.css?'.filemtime($cssPath).'" type="text/css" rel="stylesheet" media="all" /><![endif]-->');
                }
            }
        }
    }
    
    function includeCSS($filename, $prefix = '', $type = 'all') {
        $document   = & JFactory::getDocument();      
        $cssPath = JPATH_THEMES.DS.$document->template.DS.'css'.DS.$prefix.$filename.'.css';
        $path = JBlankHelper::getPathTemplate();
        if(JFile::exists($cssPath) && filesize($cssPath) > 10) {
            $document->addStylesheet( $path.'/css/'.$prefix.$filename.'.css?'.filemtime($cssPath), 'text/css', $type );
            return true;
        }
        return false;
    }

    function includeJS($filename, $prefix = '') {
        $document   = & JFactory::getDocument();        
        $jsPath = JPATH_THEMES.DS.$document->template.DS.'js'.DS.$prefix.$filename.'.js';
        $path = JBlankHelper::getPathTemplate();
        if(JFile::exists($jsPath) && filesize($jsPath) > 10) {
            $document->addScript( $path.'/js/'.$prefix.$filename.'.js?'.filemtime($jsPath));
            return true;
        }
        return false;
    }
}
